Index: arch/x86/archtables.c
===================================================================
--- arch/x86/archtables.c	(revision 944)
+++ arch/x86/archtables.c	(working copy)
@@ -145,7 +145,7 @@
 #endif
 
 	/* The Multiboot information structure */
-	mbi = rom_table_end;
+	mbi = (void*)rom_table_end;
 	rom_table_end = write_multiboot_info(
 			      low_table_start, low_table_end,
 			      rom_table_start, rom_table_end);
Index: arch/x86/multiboot.c
===================================================================
--- arch/x86/multiboot.c	(revision 944)
+++ arch/x86/multiboot.c	(working copy)
@@ -78,12 +78,12 @@
 	struct multiboot_info *mbi;
 	int i;
 
-	mbi = rom_table_end;
+	mbi = (void*)rom_table_end;
 	memset(mbi, 0, sizeof(*mbi));
 	rom_table_end += sizeof(*mbi);
 
 	mbi->mmap_addr = (u32) rom_table_end;
-	mb_mem = rom_table_end;
+	mb_mem = (struct multiboot_mmap_entry*)rom_table_end;
 
 	/* reserved regions */
 	reserved_mem[0].addr = low_table_start;
@@ -107,5 +107,5 @@
 
 	printk(BIOS_INFO, "Multiboot Information structure has been written.\n");
 
-	return mb_mem;
+	return (unsigned long)mb_mem;
 }
